<!--#include virtual="/.narodsys/metrika_counter.html"-->
<i style="background:url(//www.tns-counter.ru/V13a****yandex_ru/ru/CP1251/tmsec=narod_total/0)"></i>
<!--#include virtual="/.narodsys/direct.html"-->



#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <time.h>
#include <math.h>


#include <uf.h>
#include <uf_obj.h>
#include <uf_object_types.h>
#include <uf_ui.h>
#include <uf_disp.h>
#include <uf_assem.h>
#include <uf_part.h>
#include <uf_attr.h>
#include <uf_vec.h>
#include <uf_csys.h>
#include <uf_modl.h>
#include <uf_defs.h>
#include <uf_mtx.h>
#include <uf_ugmgr.h>



static	FILE*	prterr;
static	int		errorCode;
static	tag_t	parent_part;
static	tag_t	fastener_cset;
static	double	ra4_ra[2];
static	logical	next_pass=FALSE;
static	char	height[20];
static	char	diam[20];
static	int		component_number=0;





//   
#define	PRTERR if(errorCode){PrintErrorMessage(errorCode,__LINE__);goto term;}






//   
static	void PrintErrorMessage(int errorCode, int line)
{
	if(errorCode)
	{
		char	message[133];

		UF_get_fail_message(errorCode,message);
		UF_UI_set_status(message);
		fprintf(prterr,"\n	errorCode=%d	message=%s	line=%d\n",
			errorCode,message,line);
		
	}
}







//   
static	int	component_init_proc(UF_UI_selection_p_t select, void* user_data)
{
	int	ret_code;
	int	num_triples=1;
	UF_UI_mask_t	mask_triples[]={UF_component_type,0,0};

	ret_code=UF_UI_set_sel_mask(select,UF_UI_SEL_MASK_CLEAR_AND_ENABLE_SPECIFIC,
		num_triples, mask_triples);
	
	if(ret_code==0)
		return UF_UI_SEL_SUCCESS;

	return UF_UI_SEL_FAILURE;

}



static	logical	set_highlight_off(tag_t	member,void* applData)
{
	errorCode=UF_DISP_set_highlight(member,0);PRTERR;

	return TRUE;
term:
	return FALSE;
}



static	logical	create_csys_and_cylinder(tag_t	member, void*	applData)
{

	static	char	part_name[200];
	static	char	refset_name[50];
	static	char	instance_name[50];
	static	double	origin[3];
	static	double	csys_matrix[9];
	static	double	transform[4][4];
	static	tag_t	matrix_id;
	static	tag_t	csys_id;

	static	UF_FEATURE_SIGN	sign	=	UF_NULLSIGN;
	static	tag_t	targ_tag		=	NULL_TAG;

	static	double	fastener_origin[3];
	static	tag_t	cyl_tag;

	errorCode=UF_ASSEM_ask_component_data
		(member,part_name,refset_name,instance_name,origin,csys_matrix,transform);PRTERR;

	errorCode=UF_MTX3_initialize(&csys_matrix[0],&csys_matrix[3],csys_matrix);PRTERR;
	errorCode=UF_CSYS_create_matrix(csys_matrix,&matrix_id);PRTERR;
	errorCode=UF_CSYS_create_csys(origin,matrix_id,&csys_id);PRTERR;

	UF_VEC3_linear_comb(1.0,origin,-ra4_ra[0]/2,&csys_matrix[6],fastener_origin);
	errorCode=UF_MODL_create_cylinder
		(sign,targ_tag,fastener_origin,height,diam,&csys_matrix[6],&cyl_tag);PRTERR;
	


	return TRUE;

term:
	return FALSE;

}



// 
int	do_it(void)

{
	//     

label_select_components:
//   
	{

		// UF_UI_select_with_class_dialog
		char*	message="   ";
		char*	title="  ";
		int		scope=UF_UI_SEL_SCOPE_ANY_IN_ASSEMBLY;
		void*	user_data=NULL;
		int		i,response,count;
		tag_t*	object;
		

		

		//  
		errorCode=UF_UI_select_with_class_dialog
			(message,title,scope,component_init_proc,NULL,
			&response,&count,&object);
		PRTERR(__LINE__);
		
		switch(response)
		{

		case UF_UI_BACK:	goto label_select_components;
		case UF_UI_CANCEL:	goto term;
		case UF_UI_OK:		break;

		}

		//  
		if(count==0)
		{
			uc1601("  !",1);
			goto label_select_components;
		}
		

		logical	result;
		logical	level=FALSE;

		if(fastener_cset != NULL_TAG)
		{
			errorCode=UF_OBJ_delete_object(fastener_cset);PRTERR;
		}

		
		errorCode=UF_ASSEM_create_cset
			(parent_part,"fastener_cset",&fastener_cset);PRTERR;

		//   
		//  <fastener_cset>
		for(i=0;i<count;i++)
		{

			errorCode=UF_DISP_set_highlight(object[i],1);PRTERR;
			errorCode=UF_ASSEM_is_member_of_cset
				(fastener_cset,object[i],&result);PRTERR;
			if( !result )
			{
				errorCode=UF_ASSEM_add_to_cset
					(fastener_cset,object[i],level);PRTERR;
				component_number++;
			}
			
		}


		fprintf(prterr,	"\n component_number = %d  "
						"	line = %d \n",component_number,__LINE__);
		UF_free(object);
		
	}





	//display_keyboard_entry_menu_and_obtain_a_real_response
//obtain_length_and_diam:
	{
		char*	cp1="   ";
		char	cp2[][16]={" = "," = "};
		int		ip3=2;//  
		double	ra4[2]={20.0,2.7};
		int*	ip5=NULL;//unused

		//   
		if(next_pass)
		{
			ra4[0]=ra4_ra[0];
			ra4[1]=ra4_ra[1];
		}

		errorCode=uc1609(cp1,cp2,ip3,ra4,ip5);
		switch(errorCode)
		{
		case 1:					
				goto label_select_components;
		case 2:				
				//  
				errorCode=UF_OBJ_delete_object(fastener_cset);PRTERR;
				goto loop;

		case 3:
				//  
				errorCode=UF_ASSEM_apply_to_cset
					(fastener_cset,set_highlight_off,NULL);PRTERR;
				break;
		case 4:
				//  
				errorCode=UF_ASSEM_apply_to_cset
					(fastener_cset,set_highlight_off,NULL);PRTERR;
				break;
		case 8:
				fprintf(prterr,	"\n		Dissallowed state, unable to bring up dialog!"
								"		line=%d\n",__LINE__);
			
				//  
				errorCode=UF_OBJ_delete_object(fastener_cset);PRTERR;
				goto loop;
		}

		ra4_ra[0]=ra4[0];
		ra4_ra[1]=ra4[1];

		sprintf_s(height,"%f",ra4_ra[0]);
		sprintf_s(diam,"%f",ra4_ra[1]);
		fprintf(prterr,"\n height = %s		diam = %s	line = %d \n",height,diam,__LINE__);

		errorCode=UF_ASSEM_apply_to_cset_members
			(fastener_cset,create_csys_and_cylinder,NULL);PRTERR;

	}








loop:
	{
		char	cp1[]="   ?";
		int		ip2=5;
		char	cp3[][38]={" "," "};
		int		ip4=2;
		int		ret_code;

		ret_code=uc1603(cp1,ip2,cp3,ip4);
		switch(ret_code)
		{
		case 1:
			goto loop;
		case 2:
			//  
			errorCode=UF_OBJ_delete_object(fastener_cset);PRTERR;
			goto term;
		case 5:
			next_pass = TRUE;
			goto label_select_components;
		case 6:
			//  
			errorCode=UF_OBJ_delete_object(fastener_cset);PRTERR;
			goto term;
		case 19:
			fprintf(prterr,	"\n Disallowed state,	"
							" unable to bring up dialog	"
							"	line = %d \n",__LINE__);
			break;
		}

	}


	goto term;
term:
	return errorCode;

}








/*****************************************************************************
**  Activation Methods
*****************************************************************************/
/*  Explicit Activation
**      This entry point is used to activate the application explicitly, as in
**      "File->Execute UG/Open->User Function..." */
extern DllExport void ufusr( char *parm, int *returnCode, int rlen )
{
	//   
	struct	tm	newtime;
	time_t	aclock,start_time,finish_time;
	double	work_time;
	int		min,sec;
	char*	name="";
	
	
	time(&start_time);	// 

	//     D:		
	if(fopen_s(&prterr,"D:\\prterr.txt","w")==0)
		goto label_clock;

	//     C:		
	if(fopen_s(&prterr,"C:\\prterr.txt","w")==0)
		goto label_clock;


	uc1601("    ",1);
	return;

label_clock:
	time(&aclock);
	localtime_s(&newtime,&aclock);
	fprintf(prterr,"\n <holes_by_existing_fasteners>	HAS STARTED		line=%d\n",__LINE__);

	char	asctime_string[100];

	asctime_s(asctime_string,&newtime);
	fprintf(prterr,"\n    :	%s\n\n",asctime_string);

	errorCode=UF_initialize();PRTERR;



	
	//     
	parent_part=UF_PART_ask_display_part();
	if(parent_part==NULL_TAG)
	{
		uc1601("  ",1);
		fprintf(prterr,"\n	   	line=%d\n",__LINE__);
		goto term;
	}


	parm=name;
	

	*returnCode=do_it();


	errorCode=UF_terminate();PRTERR;

	
term:
	time(&finish_time);
	work_time=difftime(finish_time,start_time);
	min=(int)work_time/60;
	sec=(int)(work_time-min*60);
	fprintf(prterr,"\n <holes_by_existing_fasteners>	HAS FINISHED	line=%d\n",__LINE__);
	fprintf(prterr,"\n working time is %u min   %u sec\n",min,sec);

	fflush(prterr);
	fclose(prterr);
	return;
}

/*****************************************************************************
**  Utilities
*****************************************************************************/

/* Unload Handler
**     This function specifies when to unload your application from Unigraphics.
**     If your application registers a callback (from a MenuScript item or a
**     User Defined Object for example), this function MUST return
**     "UF_UNLOAD_UG_TERMINATE". */
extern int ufusr_ask_unload( void )
{
    return( UF_UNLOAD_IMMEDIATELY );
}